<?php
/*************************************************************

 File: action.php3
 Author: gernot
 Revision: 1.0.0
 Date: 1999/05/30

 This script is the core of this Admin-Tool the hole actions are 
 executed from here

 Copyright 1999 Gernot Stocker <muecketb@sbox.tu-graz.ac.at>

 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 THIS PROGRAM IS AS IT IS! THE AUTHOR TAKES NO RESPONSABILTY ABOUT 
 EVENTUAL DEMAGES, SECURITS-HOLES OR ATTACKES, WHICH COULD BE ENABLED 
 BY THIS PROGRAM

 ***************************************************************/

/*
    The central part of the WebCyradm! From here actions will be called!
    needed variables:
      
           $username =   Name of the owner of der mailbox
	   $aktion =
	      
	     FOLDERFUNCTIONS:
		ask_del_folder  = security before deleting folder
				   [folder] which has to be deleted
		del_folder      = execution of deleting folder
				   [folder] which has to be deleted
		create_folder   = creation of folder
		ren_folder      = renaming the last sunfolder of the folder
		set_quota       = setting quotas for mailbox
		abort           = aborting action
		

	     ACL-FUNCTIONS: 
	      	ask_add_user    = 
		add_user        =
		set_acl         =
		del_acl         =
		new_acl         =


             CYRUS-Config:		    
		ask_configure   = load existing or default settings of the Cyrus Imap-Server 
		write_config    = writing specified configuration settings into a file 
	   
	   $cyrus_config_file
			    
*/
  if(!isset($PHP_AUTH_USER)) 
      {
             Header("WWW-Authenticate: Basic realm=\"MailAdmins\"");
                     Header("HTTP/1.0 401 Unauthorized");
		     echo "You need a valid user and password to access this page!";
		     exit; 
      }
  require("lib/cyradm-php.lib");
  require("lib/cyrus-config.lib");
  require("config/config.php3");
  define("INCPATH", "includes");
  
//  define("IMAP_CONFIG_PATH", "/tmp/imapd.conf");

  $cimap = new cyradm;
  $user_name_array=split("/",$username);
  if (strcmp($user_name_array[0],"user")==0)
        {$chin = substr($user_name_array[1], 0, 1);}
	else
	{$chin = substr($username, 0, 1);}


	
/* ####################################################
              FOLDER FUNCTIONS
   #################################################### */

  switch ($aktion) {

	  case "ask_del_folder":
              include(INCPATH."/header.inc");
	      include(INCPATH."/act_0_ask_for_del_folder.inc"); 
              include(INCPATH."/footer.inc");
	     break;


	  case "del_folder":
              include(INCPATH."/act_1_header_for_deleting_user.inc");
              print "<center><hr><H1><blink>Removed FOLDER</blink>: $folder <br></H1><hr></center>";
	      $folder=str_replace("/"," ",$folder);
	      $folder=trim($folder);
	      $folder=str_replace(" ", ".", $folder);
	      $cimap->imap_login();
	      $cimap->deletemb($folder);
 	      $cimap->imap_logout();
	      $username=trim($username);
	      $folder=str_replace(".", "/", $folder);
	      print "<center>";
    	      if (strcmp($folder,$username)==0) 
	        { print "<a href=\"main.html\"><img src=\"graphics/back.jpg\" border=\"0\"></a>";} 
	      else 
		{ print "<a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a>";}
              include(INCPATH."/footer.inc");
	      print "</center>";
	     break;


	  case "create_folder":
	      include(INCPATH."/header.inc");
	      if (strlen($newfolder)!=0)
	      {
  	        $folder = str_replace("/", " ", $folder);
	        $folder = trim($folder);
	        $folder = str_replace(" ", ".", $folder).".".$newfolder;
	        $cimap->imap_login();
	        $cimap->createmb($folder);
	        $cimap->imap_logout();
	        print "<br><hr><center><H1>Creating Folder</H1>
                       <table border=1 cellpadding=5><tr><td>
		       <H3>Folder $folder created!</H3>
		       </td></tr></table>
		       </center><hr><br>";
	      }
	      else
	      { 
	        print "<br><hr><center><H1><blink>Error:</blink>New Folder not specified!!</H1></center><hr><br><br>";
	      }
              print "<center><a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
              include(INCPATH."/footer.inc");
	     break;



	  case "ren_folder":
              include(INCPATH."/header.inc");
              $newfolder=trim($newfolder);
	      if (strcmp($newfolder,"")!=0)
               {
                $newfolderarray=split("/",$folder);
	         $folder = str_replace("/", " ", $folder);
	         $folder = trim($folder);
	         $folder = str_replace(" ", ".", $folder);

                $renfolder=$newfolderarray[0];
		
                for ($i=1; $i < (count($newfolderarray)-1); $i++)
	         {
	          if ($newfolderarray[$i]) { $renfolder=$renfolder.".".$newfolderarray[$i];}
	         }

	        $renfolder=$renfolder.".".$newfolder;
	        $cimap->imap_login();
	        $cimap->renamemb($folder,$renfolder);
	        $cimap->imap_logout();
                include(INCPATH."/header.inc");
	        print "<center><br><hr>
		       <H1>RENAMING</H1>
		       <table border=1 cellpadding=7>
		       <tr><td><H3><b>Folder:</b>$folder</H3></td><td><H3><b>Renamed to:</b> $renfolder </H3></td><tr></table><hr>
		      ";
               }
	       else
	       {
	        print "<br><hr>
		        <H1><center>
			<blink>Error</blink>: New FOLDERNAME not specified!!
			<center></H1><hr><br>";
	       }
 	      print "<a href=\"info.php3?username=$username\" target=\"info\" border=\"0\"><img src=\"graphics/back.jpg\" border=0></a></center>";
	      include(INCPATH."/footer.inc");
	     break;

          case "ask_rec_rename":
	      include(INCPATH."/header.inc");

              $newfolder=trim($newfolder);
	      if (strcmp($newfolder,"")!=0)
               {
	        $cimap->imap_login();
	        $folderarray=$cimap->EGetFolders($folder);
	        $cimap->imap_logout();
	        print "<center><hr><H1>RECURSIVE RENAME</H1><hr></center>
		       <table align=center border=0 cellpadding=5 cellspacing=5>
		       <tr><b>Do you really want renaming the following folders?</b><br></tr> 
		       ";
                $offset=split ("/",$folder);
	        $position=count($offset)-1;
	        for ($i=0; $i< count($folderarray); $i++){
                   $farray=split("/",$folderarray[$i]);
		   $farray[$position]=$newfolder;
		   $torename=$farray[0];
		   for ($k=1; $k< count($farray); $k++){
                     $torename="$torename"."/"."$farray[$k]";   
		     }
		   print "<tr><td>From: </td><td><b>$folderarray[$i]</b></td><td>To: </td><td><b>$torename</b></td></tr>";
	          }
	        print "<tr><td></td><td><a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></td>
		       <td></td><td>
	               <a href=\"action.php3?username=$username&aktion=rec_rename&folder=$folder&newfolder=$newfolder\"><img src=\"graphics/ok.jpg\" border=\"0\"></a></td></tr></table>";
               }
	       else
	       {
	        print "<br><hr>
		        <H1><center>
			<blink>Error</blink>: FOLDERNAME for renaming not specified!!
			<center></H1><hr><br>
 	                <a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	       }
	      include(INCPATH."/footer.inc");
	     break;
	  
          case "rec_rename":
	      include(INCPATH."/header.inc");
	      $cimap->imap_login();
	      $folderarray=$cimap->EGetFolders($folder);
              $offset=split ("/",$folder);
	      $position=count($offset)-1;
	      print "<hr><center><H1>RECURSIVE - RENAME</center></H1><hr>
	             <table border=0 align=center cellpadding=5 cellspacing=5>";
	      for ($i=0; $i< count($folderarray); $i++){
                 $farray=split("/",$folderarray[$i]);
		 $farray[$position]=$newfolder;
		 $torename=$farray[0];
		 for ($k=1; $k< count($farray); $k++){
                   $torename="$torename"."/"."$farray[$k]";   
		   }
		 print "<tr> <td><b>$folderarray[$i]</B></td> <td>renamed to</td> <td><B>$torename</b></td></tr>";
		 $folderarray[$i]=str_replace("/",".",$folderarray[$i]);
		 $torename=str_replace("/",".",$torename);		 
		 $cimap->renamemb($folderarray[$i],$torename); 
		}
	      $cimap->imap_logout();
	      print "</table>";
	      print "<center><br><a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";

	      include(INCPATH."/footer.inc");
	     break;

          case "ask_rec_delete":
   	        include(INCPATH."/header.inc");
                $newfolder=trim($newfolder);
	        $cimap->imap_login();
	        $folderarray=$cimap->EGetFolders($folder);
	        $cimap->imap_logout();
	        print "<center><hr><H1>RECURSIVE Delete</H1><hr></center>
		       <table align=center border=0 cellpadding=3 cellspacing=3>
		       <tr><b>Do you really want deleting the following folders?</b><br></tr> 
		       ";
	        for ($i=0; $i< count($folderarray); $i++){
		   print "<tr><td></td><td>$folderarray[$i]</td><td></td></tr>";
	          }
	        print "<tr><td><a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></td>
		       <td></td><td><a href=\"action.php3?username=$username&aktion=rec_delete&folder=$folder&newfolder=$newfolder\"><img src=\"graphics/ok.jpg\" border=\"0\"></a></td></tr></table>";
 	        include(INCPATH."/footer.inc");
	     break;
	  
          case "rec_delete":
	      include(INCPATH."/header.inc");
	      $cimap->imap_login();
	      $folderarray=$cimap->EGetFolders($folder);
	      print "<hr><center><H1>RECURSIVE - DELETE</center></H1><hr>
	             <table border=0 align=center cellpadding=5 cellspacing=5>";
	      for ($i=(count($folderarray)-1); $i>= 0; $i--){
		 print "<tr> <td><b>$folderarray[$i]</B></td><td>deleted!</td></tr>";
		 $folderarray[$i]=str_replace("/",".",$folderarray[$i]);
		 $cimap->deletemb($folderarray[$i]); 
		}
	      $cimap->imap_logout();
	      print "</table>";
	      if (strcmp($username,$folder)==0)
	      {
	       print "<center><br><a href=\"main.html\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      }
	      else
	      {
	       print "<center><br><a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      }
	      include(INCPATH."/footer.inc");
	     break;

	  case "set_quota":
              include(INCPATH."/header.inc");
              $testval=doubleval($newfolder);
	      if ($testval)
	      {
	        $cyr = new cyradm;
                $cyr->imap_login();
		$imapusername=str_replace("/",".",$username);
                $quota = $cyr->getquota("$imapusername");
		$cyr->setmbquota("$imapusername", $newfolder);
                $cyr->imap_logout();

                print("<hr><center><H1>QUOTA</H1> <br>");
                print "<table border=1 cellpadding=7><tr><td> <H3>Used: $quota[used] kB <br></td><td><b>MAXIMUM</b> changed from: <b>$quota[qmax] kB</b> to: <b>$newfolder kB</b></td></tr></H3></table>";
	        print "<br><hr><br><a href=\"info.php3?username=$username\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";

	      }
	      else
	      {
		print "<center><br><hr><H1><blink>Error</blink>: QUOTAFIELD is empty/not specified!!</H1><hr><br><a href=\"info.php3?username=$username\"> <img src=\"graphics/back.jpg\" border=\"0\"> </a></center>";
	      };
              include(INCPATH."/footer.inc");
	     break;


	  case "ask_add_user":
	      $ccf = new config;
	      $quotaval=$ccf->get_config_tag($IMAP_CONFIG_PATH,"autocreatequota");
              include(INCPATH."/act_2.5_update_status.inc");
	      include(INCPATH."/act_3_ask_add_user_on_acl.inc");
              include(INCPATH."/footer.inc");
	  break;


	  case "add_user":
	     if (strcmp($username,"user.")!=0)
	      {
	       $cimap->imap_login();
	       $cimap->createmb("$username");
               $username_array=split("\.",$username);
	       if (strcmp($quota,"")==0) { $quota=15000; };
	       $cimap->setmbquota("$username","$quota");
	       $cimap->imap_logout();

	       $infouser=str_replace(".","/",$username);
               $bc=$username_array[1][0];
               include(INCPATH."/act_4_add_user.inc");
	      }
	     else
	      { 
               include(INCPATH."/header.inc");
		print "<center><br><hr><H1><blink>Error</blink>: USERNAME is empty/not specified!!</H1><hr><br><a href=\"action.php3?aktion=ask_add_user\"> <img src=\"graphics/back.jpg\" border=\"0\"> </a></center>";
	      }
	       include(INCPATH."/footer.inc");

	  break;

/* ####################################################
                   ACL FUNCTIONS
   #################################################### */

	  case "set_acl":
              $folder_orig=$folder;
              $folder=str_replace("/", ".",$folder);
	      $new_acl="$lookup"."$read"."$seen"."$write"."$insert"."$post"."$create"."$delete"."$administer";

	      $cimap->imap_login();
	      if (strlen($new_acl)==0)
		 { $cimap->deleteacl($folder, $acluser); }
	      else
		 { $cimap->setacl($folder, $acluser, $new_acl); }
              $cimap->imap_logout();
	      
/*              $folder=str_replace(".", "/",$folder);
	      $folder_a=split("/",$folder,-1);
              $folder = "";
  	      for ($i=1; $i<count($folder_a); $i++)
	        {
		 if ($i==count($folder_a)-1)
		  { $folder=$folder.$folder_a[$i];
		  }
		  else
		  {
                  $folder=$folder.$folder_a[$i]."/";
		  };
		}*/
              include(INCPATH."/header.inc");
	      print "<center><hr><H1>SET AccessList</H1><hr>
                     <table border=0 cellpadding=5>
	              <tr><td><b>Owner of the Mailbox:</b></td><td>$username</td></tr> 
	              <tr><td><b>gives rights:</b></td><td>$new_acl</td></tr> 
	              <tr><td><b>on the folder:</b></td><td>$folder</td></tr> 
	              <tr><td><b>for the ACL-User:</b></td><td>$acluser</td></tr> 
		     </table><hr>"; 
	      print "<br><a href=\"acl.php3?username=$username&folder=$folder_orig\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
              include(INCPATH."/footer.inc");
	     break;
	      

	  case "del_acl":
              include(INCPATH."/header.inc");
              $folder=str_replace("/", ".",$folder);
	      $cimap->imap_login();
	      $cimap->deleteacl($folder, $acluser);
	      $cimap->imap_logout();
              $folder=str_replace(".", "/", $folder);
	      
	      print "<center><hr><H1>Delteting USER from Folder-AccessList</H1><hr>
                     <table border=0 cellpadding=5>
	             <tr><td><b>The user:</b><td><td>$acluser</td></tr> 
	             <tr><td><b>is deleted from ACL of:</b><td><td>$folder</td></tr>
	             <tr><td><b>of the Owner:</b><td><td>$username</td></tr> 
		     </table><hr>\n
     	             <br><a href=\"acl.php3?username=$username&folder=$folder\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      include(INCPATH."/footer.inc");
	     break;


	  case "new_acl":
	      include(INCPATH."/header.inc");
	      $new_acl="$lookup"."$read"."$seen"."$write"."$insert"."$post"."$create"."$delete"."$administer";
	      if (strlen($acluser)==0 ||strlen($new_acl)==0 ) 
		{ print "<center><hr><br><H1> <blink>ERROR</blink>: Username or AccessRights not set!!</H1><hr><br> 
			 <a href=\"acl.php3?username=$username&folder=$folder\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>\n
			";
		}
	      else
		{ $imapfolder=str_replace("/", ".",$folder);    
	          $cimap->imap_login();
	          $cimap->setacl($imapfolder, $acluser, $new_acl);
	          $cimap->imap_logout();
                  include(INCPATH."/header.inc");
 		  print "<center><hr><H1>Adding USER to Folder-AccessList</H1><hr>
                         <table border=0 cellpadding=5>
			 <tr><td><b>The user:</b><td><td>$acluser</td></tr>
			 <tr><td><b>added to ACL of:</b><td><td>$folder</td></tr>
			 <tr><td><b>of:</b><td><td>$username</td></tr>
			 <tr><td><b>with rights:</b><td><td>$new_acl</td></tr>
		         <br>
			 </table><hr>
			 <a href=\"acl.php3?username=$username&folder=$folder\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>\n";

		  }
                  include(INCPATH."/footer.inc");
	     break;



/* ####################################################
              Cyrus Config FUNCTIONS
   #################################################### */

          case "ask_configure":
               $conf = new config;
	       include(INCPATH."/con_0_ask_for_configuration.inc");
               $conf->get_config($IMAP_CONFIG_PATH);
	       include(INCPATH."/con_1_end_ofask_for_configuration.inc");
	      break;


          case "write_config":
	       $conff=fopen($IMAP_CONFIG_PATH, "w+");
	       fwrite($conff,"configdirectory: $configdirectory\n");
	       fwrite($conff,"partition-default: $partitiondefault\n");
	       fwrite($conff,"admins: $admins\n");
	       fwrite($conff,"allowanonymouslogin: $allowanonymouslogin\n");
	       fwrite($conff,"autocreatequota: $autocreatequota\n");
	       fwrite($conff,"reject8bit: $reject8bit\n");
	       fwrite($conff,"quotawarn: $quotawarn\n");
	       fwrite($conff,"timeout: $timeout\n");
	       fwrite($conff,"prime-ldaphost: $primeldaphost\n");
	       fwrite($conff,"backup-ldaphost: $backupldaphost\n");
	       fwrite($conff,"ldapport: $ldapport\n");
	       fwrite($conff,"ldapusercontext: $ldapusercontext\n");
	       fclose($conff);
               include(INCPATH."/header.inc");
               print "<center><hr><H1> Config-File written to ($IMAP_CONFIG_PATH)!</H1></center>";
	       include(INCPATH."/con_2_end_of_writing_config_file.inc");
	       include(INCPATH."/footer.inc");
              break;
	  }  
?>
